package com.adventurer_engine.common.items;

package .tmp;

import by;
import cg;
import ci;
import com.adventurer_engine.common.CommonConfig;
import com.adventurer_engine.common.gadgets.DamagePacket;
import com.adventurer_engine.common.gadgets.RangeAttackPacket;
import com.adventurer_engine.common.items.TabsLoader;
import com.adventurer_engine.common.items.blank.BasicItem;
import com.adventurer_engine.common.items.blank.BasicItemSword;
import com.adventurer_engine.common.items.blank.ranged_weapon.BasicAmmo;
import com.adventurer_engine.common.items.blank.ranged_weapon.BasicRangedWeapon;
import com.adventurer_engine.common.items.gadget.ItemBackpack;
import com.adventurer_engine.common.items.gadget.ItemDuring;
import com.adventurer_engine.common.items.gadget.ItemGreenRing;
import com.adventurer_engine.common.items.gadget.ItemLifeGem;
import com.adventurer_engine.util.DebugGadgets;
import com.adventurer_engine.util.JsonHelper;
import com.google.gson.internal.StringMap;
import cpw.mods.fml.common.event.FMLPreInitializationEvent;
import cpw.mods.fml.common.registry.GameRegistry;
import java.io.ByteArrayInputStream;
import java.io.DataInputStream;
import java.io.File;
import java.io.InputStream;
import java.math.BigInteger;
import java.security.MessageDigest;
import java.util.ArrayList;
import java.util.List;
import javax.crypto.Cipher;
import javax.crypto.spec.IvParameterSpec;
import javax.crypto.spec.SecretKeySpec;
import yc;

public class ItemLoader {
  public static final List<yc> item = new ArrayList<yc>();
  
  public static final StringMap<BasicAmmo> ammoItem = new StringMap();
  
  public static ItemBackpack itemBackpack;
  
  public static ItemDuring itemDuring;
  
  public static ItemLifeGem itemLifeGem;
  
  public static ItemGreenRing itemGreenRing;
  
  private static final String CERT_SHA256 = "f574c6b8f03df8eb016a531c269b3dc1af4a7c275ef0f04b9274edecc5c22c2a";
  
  private static String computeSHA256(byte[] data) {
    try {
      MessageDigest md = MessageDigest.getInstance("SHA-256");
      byte[] digest = md.digest(data);
      return byteHex2String(digest);
    } catch (Exception ignored) {
      return "";
    } 
  }
  
  private static String byteHex2String(byte[] data) {
    BigInteger number = new BigInteger(1, data);
    StringBuilder hexString = new StringBuilder(number.toString(16));
    while (hexString.length() < 64)
      hexString.insert(0, '0'); 
    return hexString.toString();
  }
  
  public static byte[] AESDecrypt(byte[] encryptedData) throws Exception {
    byte[] key = new byte[16];
    System.arraycopy(encryptedData, 0, key, 0, 16);
    byte[] iv = new byte[16];
    System.arraycopy(encryptedData, 16, iv, 0, 16);
    byte[] data = new byte[encryptedData.length - 32];
    System.arraycopy(encryptedData, 32, data, 0, data.length);
    Cipher cipher = Cipher.getInstance("AES/CBC/PKCS5Padding");
    SecretKeySpec secretKeySpec = new SecretKeySpec(key, "AES");
    IvParameterSpec ivParameterSpec = new IvParameterSpec(iv);
    cipher.init(2, secretKeySpec, ivParameterSpec);
    return cipher.doFinal(data);
  }
  
  private static void registerGadgetItems() {
    itemBackpack = new ItemBackpack();
    GameRegistry.registerItem((yc)itemBackpack, itemBackpack.a());
    itemDuring = new ItemDuring();
    GameRegistry.registerItem((yc)itemDuring, itemDuring.a());
    itemLifeGem = new ItemLifeGem();
    GameRegistry.registerItem((yc)itemLifeGem, itemLifeGem.a());
    itemGreenRing = new ItemGreenRing();
    GameRegistry.registerItem((yc)itemGreenRing, itemGreenRing.a());
  }
  
  public static void load(FMLPreInitializationEvent event) {
    registerGadgetItems();
    try {
      InputStream in = com.adventurer_engine.common.items.ItemLoader.class.getResourceAsStream("/test.dat");
      if (in == null)
        return; 
      byte[] originData = new byte[in.available()];
      in.read(originData);
      in.close();
      DataInputStream inputStream = new DataInputStream(new ByteArrayInputStream(originData));
      by nbt = ci.a(inputStream);
      DebugGadgets.debugInfo("Read NBTs");
      loadNBT(nbt);
    } catch (Exception e) {
      DebugGadgets.debugInfo(e.toString());
      e.printStackTrace();
    } 
  }
  
  private static void loadJson(FMLPreInitializationEvent event) {
    File itemPath = new File(event.getModConfigurationDirectory().getParentFile().getPath() + File.separator + "RCS" + File.separator + "items");
    BasicItem newItem = null;
    for (File f : itemPath.listFiles()) {
      JsonHelper json = new JsonHelper(f);
      List<StringMap> itemDatas = json.getList("items");
      String module = json.getString("module");
      for (StringMap data : itemDatas) {
        BasicAmmo basicAmmo;
        JsonHelper itemData = new JsonHelper(data);
        String itemType = itemData.getString("type");
        if ("normal".equals(itemType)) {
          newItem = new BasicItem(CommonConfig.itemStartID++, itemData, module);
        } else if ("sword".equals(itemType)) {
          BasicItemSword basicItemSword = new BasicItemSword(CommonConfig.itemStartID++, itemData, module);
        } else if ("ranged_weapon".equals(itemType)) {
          BasicRangedWeapon basicRangedWeapon = new BasicRangedWeapon(CommonConfig.itemStartID++, itemData, module);
        } else if ("ammo".equals(itemType)) {
          basicAmmo = new BasicAmmo(CommonConfig.itemStartID++, itemData, module);
        } 
        if (basicAmmo != null) {
          item.add(basicAmmo);
          GameRegistry.registerItem((yc)basicAmmo, basicAmmo.a());
        } 
      } 
    } 
  }
  
  private static void loadNBT(by nbt) {
    DebugGadgets.debugInfo("Try to Load Item data");
    if (!nbt.b("root"))
      return; 
    nbt = nbt.l("root");
    TabsLoader.load(nbt);
    DebugGadgets.debugInfo("load tabs done.");
    if (nbt.b("AttackPacket")) {
      cg ls = nbt.m("AttackPacket");
      for (int i = 0; i < ls.c(); i++)
        new DamagePacket((by)ls.b(i)); 
    } 
    DebugGadgets.debugInfo("load AttackPacket done.");
    if (nbt.b("FireArmAttribute")) {
      cg ls = nbt.m("FireArmAttribute");
      for (int i = 0; i < ls.c(); i++)
        new RangeAttackPacket((by)ls.b(i)); 
    } 
    DebugGadgets.debugInfo("load FireArmAttribute done.");
    if (nbt.b("Item")) {
      cg ls = nbt.m("Item");
      for (int i = 0; i < ls.c(); i++) {
        BasicItem newItem = new BasicItem((by)ls.b(i));
        item.add(newItem);
        GameRegistry.registerItem((yc)newItem, newItem.a());
      } 
    } 
    DebugGadgets.debugInfo("load Item done.");
    if (nbt.b("AMMO")) {
      cg ls = nbt.m("AMMO");
      for (int i = 0; i < ls.c(); i++) {
        BasicAmmo basicAmmo = new BasicAmmo((by)ls.b(i));
        item.add(basicAmmo);
        GameRegistry.registerItem((yc)basicAmmo, basicAmmo.a());
      } 
    } 
    DebugGadgets.debugInfo("load AMMO done.");
    if (nbt.b("ColdWeapon")) {
      cg ls = nbt.m("ColdWeapon");
      for (int i = 0; i < ls.c(); i++) {
        BasicItemSword basicItemSword = new BasicItemSword((by)ls.b(i));
        item.add(basicItemSword);
        GameRegistry.registerItem((yc)basicItemSword, basicItemSword.a());
      } 
    } 
    DebugGadgets.debugInfo("load ColdWeapon done.");
    if (nbt.b("Gun")) {
      cg ls = nbt.m("Gun");
      for (int i = 0; i < ls.c(); i++) {
        BasicRangedWeapon basicRangedWeapon = new BasicRangedWeapon((by)ls.b(i));
        item.add(basicRangedWeapon);
        GameRegistry.registerItem((yc)basicRangedWeapon, basicRangedWeapon.a());
      } 
    } 
    DebugGadgets.debugInfo("load Gun done.");
  }
}
